//IOBase.h
#include <fstream.h>

/*** defines ***/
// switch for all debugging info
//#define DEBUG

/*** classes in this header ***/
class TIOBase; 

///////////////////TTIOBase
// a container class for trival common variables and functions.
// Handle the fileIO.
class TIOBase
{
public:
  // We leave the standart constructor empty, and do all the initializations
  // in the other one. The empty one is necessairy for TTopoCreator and
  // TPatternManager, becase their constructors are empty too. But as thier
  // classes exist only virtually for TRNN, the empty constructor of 
  // TIOBase will never be called. So no one will realize that it doesn't
  // do its work properly.
  TIOBase();
  ~TIOBase();
protected:
  // possible Mode parameters are defined in clsss ios (ios::out,in,...)
  // The childs are responsible closing and deleting the file again. 
  char OpenFile(char* acFilename, int aiMode);
  char OpenFile(fstream *apF, char* acFilename, int aiMode);
  char CloseFile();
  char CloseFile(fstream *apF);
  char ReadComment();
  char ReadComment(fstream *apF);
  bool DirContainsFile(bool SubSearch, char *fn);
  int Keypressed(char &ac);
  void KeyCheck();
  // Double to stream and the other way round.
  static void d2s(iostream *s, double &d) { *s << d; }
  static void s2d(iostream *s, double &d) { *s >> d; }
  // For long doubles.
  static void ld2s(iostream *s, long double &d) {
    double dd; dd=(double)d; *s << dd; } 
  static void s2ld(iostream *s, long double &d) {
    double dd; *s >> dd; d=dd; } 
  long lFilePos; // to rescan the file begining after the global section
  // Just for the kids to have a char at hand.
  char cKey;
/* private: */
  // We keep only one fstream object alive and open - close the files
  // instead of new - delete an fstream object every time we read a file.
  fstream *pFile; // common stream pointer for all friend-childs
  char cFilename[256];
  int iFileRdState; // the status of the file.
};







