// MathMacros.h
#include <math.h>
//#include <machine/endian.h>

#define SQR(x) ((x) * (x))

// macro for fast exp
static union {
  double d;
  struct {
    // machine dependent storage of multi-byte quantities.
#ifdef LITTLE_ENDIAN
    int j, i;
#else
    int i, j;
#endif
  } n;
} _eco, _eco2;

#define EXP(y) ((_eco.n.i = (int)(1512775*(y)) + 1072632448,_eco.n.j=0),\
 _eco.d)


/* logistic: logc(y) = EXP(y/2)/(EXP(y/2) + EXP(-y/2)) */      

/* auxiliary constants */

#define POW_2_20 (1 << 20) 
#define POW_1023 (1023*POW_2_20)
#define POW_2045 (2045*POW_2_20)

#define EXP_A (POW_2_20/M_LN2)  /* use 1512775 for int */

#define LOGC(y) (_eco2.n.i = (int)(POW_1023 - (EXP_A/2)*(y)), \
    _eco.n.i = (POW_2045 + POW_2_20) - _eco2.n.i, _eco.d/(_eco.d + _eco2.d))


 


